﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Win.UltraWinEditors;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
		private UltraCombo _cmbTest = new UltraCombo();

        public Form1()
        {
            InitializeComponent();
			this.Controls.Add(_cmbTest);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			_cmbTest.InitializeLayout += new InitializeLayoutEventHandler(_cmbTest_InitializeLayout);
			LoadDataTables();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
			//e.Layout.ViewStyle = ViewStyle.SingleBand;
			e.Layout.GroupByBox.Hidden = true;
			ColumnsCollection cols = e.Layout.Bands[0].Columns;
			if (!cols.Exists("FUNDING_SOURCES"))
				cols.Add("FUNDING_SOURCES");

			foreach (UltraGridColumn col in cols)
			{
				switch (col.Key.ToUpper())
				{
					case "CONTRACTS":
						col.Header.Caption = "Contracts";
						break;

					case "START_DATE":
						col.Header.Caption = "Start Date";
						break;

					case "END_DATE":
						col.Header.Caption = "End Date";
						break;

					case "FUNDING_SOURCES":
						col.DataType = typeof(List<object>);
						col.Header.Caption = "Funding Sources";
						col.EditorControl = _cmbTest;
						col.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
						col.Hidden = false;
						break;

					default:
						col.Hidden = true;
						break;
				}
			}

			e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;
        }

		private void _cmbTest_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            UltraGridColumn column = e.Layout.Bands[0].Columns.Add("CHECKED");
            column.DataType = typeof(bool);
			column.Header.Caption = "Apply";

			_cmbTest.DropDownStyle = UltraComboStyle.DropDownList;
			this._cmbTest.DisplayMember = "NAME";
			this._cmbTest.ValueMember = "ID";
			this._cmbTest.CheckedListSettings.CheckStateMember = "CHECKED";
			this._cmbTest.CheckedListSettings.EditorValueSource = Infragistics.Win.EditorWithComboValueSource.CheckedItems;
        }

		private void LoadDataTables()
		{
			DataTable dt = new DataTable();
			dt.Columns.Add("CONTRACTS", typeof(string));
			dt.Columns.Add("START_DATE", typeof(DateTime));
			dt.Columns.Add("END_DATE", typeof(DateTime));
			dt.Columns.Add("FUNDING_DATA", typeof(List<int>));

			dt.Rows.Add(new object[4] { 
				"National Contract", 
				DateTime.Now, 
				new DateTime(DateTime.Now.Year, 12, 31),
				DBNull.Value});

			List<int> list1 = new List<int>();
			list1.Add(1);
			list1.Add(2);

			dt.Rows.Add(new object[4] { 
				"State Contract", 
				DateTime.Now, 
				new DateTime(DateTime.Now.Year, 12, 31),
				list1});

			List<int> list2 = new List<int>();
			list2.Add(3);
			list2.Add(5);

			dt.Rows.Add(new object[4] { 
				"State Contract", 
				DateTime.Now, 
				new DateTime(DateTime.Now.Year, 12, 31),
				list2});

			ugTest.DataSource = dt;

			DataTable dt2 = new DataTable();
			dt2.Columns.Add("ID", typeof(int));
			dt2.Columns.Add("NAME", typeof(string));

			dt2.Rows.Add(new object[2] { 1, "One" });
			dt2.Rows.Add(new object[2] { 2, "Two" });
			dt2.Rows.Add(new object[2] { 3, "Three" });
			dt2.Rows.Add(new object[2] { 4, "Four" });
			dt2.Rows.Add(new object[2] { 5, "Five" });

			_cmbTest.DataSource = dt2;
		}

		private void ugTest_InitializeRow(object sender, InitializeRowEventArgs e)
		{
			List<object> listObj = new List<object>();
			if (e.Row.GetCellValue("FUNDING_DATA") != null &&
				e.Row.GetCellValue("FUNDING_DATA") != DBNull.Value)
			{
				List<int> listInt = e.Row.GetCellValue("FUNDING_DATA") as List<int>;
				foreach (int i in listInt)
				{
					listObj.Add(i);
				}
			}
			e.Row.Cells["FUNDING_SOURCES"].Value = listObj;
		}

		private void ugTest_BeforeRowUpdate(object sender, CancelableRowEventArgs e)
		{
			List<object> listObj = e.Row.GetCellValue("FUNDING_SOURCES") as List<object>;
			List<int> listInt = new List<int>();
			foreach (object o in listObj)
			{
				listInt.Add(Convert.ToInt32(o));
			}
			DataTable dtSource = ugTest.DataSource as DataTable;
			dtSource.Rows[e.Row.ListIndex]["FUNDING_DATA"] = listInt;
		}
    }
}
